import { BaseReducer } from './BaseReducer';
import { InternalSuccessAction, HttpTransform } from '../actions/BaseRequestAction';
import { IActionPayload } from '../actions/BaseAction';
export interface IMetaAction {
    metaKey: string | number | symbol | boolean;
    metaActionName: string;
}
export declare type MetasLoading<M> = {
    pick: (value: M) => boolean;
};
export declare type Meta = Readonly<{
    actionType: string;
    loading: boolean;
} & HttpTransform>;
export declare type Metas<M = any> = Partial<{
    [key: string]: Meta;
}> & {
    pick: (value: M) => Meta;
};
export interface IMetaRestore extends IActionPayload<{
    key: string;
    value: Meta | Metas;
}> {
}
export interface IMetaStash {
    [key: string]: Metas | Meta | 'meta-used';
}
export declare const USED_FLAG = "meta-used";
export declare const DEFAULT_META: Meta;
export declare const METAS_PICK_METHOD: {
    pick: (value: any) => Meta;
};
export declare const DEFAULT_METAS: Metas;
interface Data {
    [key: string]: Metas | Meta;
}
declare class MetaReducer extends BaseReducer<Data> {
    protected readonly stash: IMetaStash;
    constructor();
    protected getData(name: string): Meta | Metas;
    protected getMeta<T extends Meta | Metas>(name: string): T | undefined;
    protected isRestore(action: InternalSuccessAction | IMetaRestore): action is IMetaRestore;
    protected reducer(state: Data | undefined, action: InternalSuccessAction | IMetaRestore): Data;
}
export declare const metaReducer: MetaReducer;
export {};
